// TestApp1.cpp : Defines the entry point for the application.
//

#ifdef _WIN32
#include "Win32/stdafx.h"
#endif

#include <DK.h>


class TestApp1 : public DKApplication
{
	DKObject<DKWindow> window;
public:
	void OnInitialize(void) override
	{
		DKLog("%s", DKGL_FUNCTION_NAME);
		window = DKWindow::Create("DefaultWindow");
		window->Activate();

		window->AddEventHandler(this,
			DKFunction([this](const DKWindow::WindowEvent& e) {
			if (e.type == DKWindow::WindowEvent::WindowClosed)
				DKApplication::Instance()->Terminate(0);
		}),
			NULL, NULL);

		DKObject<DKGraphicsDevice> device = DKGraphicsDevice::SharedInstance();
		device->CreateCommandQueue();
	}
	void OnTerminate(void) override
	{
		DKLog("%s", DKGL_FUNCTION_NAME);
	}
};


#ifdef _WIN32
int APIENTRY wWinMain(_In_ HINSTANCE hInstance,
	_In_opt_ HINSTANCE hPrevInstance,
	_In_ LPWSTR    lpCmdLine,
	_In_ int       nCmdShow)
#else
int main(int argc, const char * argv[])
#endif
{
	TestApp1 app;
	DKPropertySet::SystemConfig().SetValue("AppDelegate", "AppDelegate");
	return app.Run();
}
